/*
   TREE TEST

   Jaime Vives Piqueres, (?)1999.

*/

// *** basics ***
#version 3.1;

// *** standard includes ***
#include "colors.inc"
#include "textures.inc"
#include "skies.inc"

// *** textures ***
#declare t_bark=
texture{
 pigment{
  granite
  turbulence 0.5
  color_map{
   [0.0 DarkTan]
   [0.4 DarkTan]
   [0.5 Gold]
   [1.0 Gray]
  }
 }
 normal{granite 4 turbulence 0.5}
 scale 8
}
#declare t_leaves=
texture{
 pigment{
  gradient z
  color_map{
   [0.0 Gold]
   [0.5 Goldenrod]
   [1.0 IndianRed]
  }
  scale 20
 }
 normal{crackle scale .5}
// finish{Dull}
}

// *** tree macros ***
#include "treemacr.inc"

// *** this tree parameters ***
#declare base_radius           =10; // trunk base radius
#declare top_radius            =1;  // trunk top radius (keep it low)
#declare sections              =40; // total trunk sections
#declare start_section_lenght  =12; // first section lenght
#declare end_section_lenght    =4;  // last section lenght
#declare branch_start_section  =5; // trunk section for first branch
#declare branch_end_section    =25; // trunk section for last, vertical branch
#declare startbranch_sections  =30; // number of sections for 1st branch
#declare startsbranch_sections =20; //        "            "   " sub-branch
#declare startlbranch_sections =10; //        "            "   " last-branch
#declare branch_v_min_angle    =20; // minimum vertical angle for branches
#declare branch_v_max_angle    =40; //    "       "       "    "  branches
#declare branch_h_rotation     =60; // succesive rotation angle for branches (horizontal)
#declare sbranch_v_min_angle   =20; // idem for sub-branches
#declare sbranch_v_max_angle   =60;
#declare sbranch_h_rotation    =60;
#declare fbranch_v_min_angle   =20; // idem for last-branches
#declare fbranch_v_max_angle   =80;
#declare fbranch_h_rotation    =60;
#declare leaves_rotation       =60; // succ. horizontal rotation for leaves
#declare branchs_per_section   =1;  // number of branches per section
#declare branch_percentage     =.2; // percentage of branches (1 means all sections have branches)
#declare sbranch_percentage    =.3; // idem for sub-branches
#declare lbranch_percentage    =.6; // idem for last-branches
#declare leaves_percentage     =.9; // idem for leaves
#declare verticality           =.8; // trunk/branch verticallity percentage
#declare curves                =.4; //      "       curves percentage
#declare number_of_roots       =3;
#declare bark_texture          =texture{t_bark}
#declare i_leaf                ="i_leaves.inc"
#declare l_switch              =on; // leaves on/off
// and finally the mos important! Change it and trace again: many times
// results are wierd, but in some ocasions it makes very nice trees.
#declare random_seed           =564;

// *** create the tree calling the include ***
#declare arbol01=
#include "tree.inc"

// *** place the tree ***
object{arbol01 rotate 40*y}

// *** simple scenario ***
plane{y,0
 pigment{DarkTan}
}
plane{z,500
 pigment{White}
}

// *** light ***
light_source{
 <10000,5500,-5495>
 White*.75+Gold*.5+SkyBlue*.25
 fade_distance 50000
 fade_power 8
}

// *** and take the shot! ***
camera{
  location <2,90,-600>
  direction 2*z
  look_at <1,110,0>
}
